/*
 *	work.h
 *
 *	GameBoy/EMU
 *
 *	* Sat Feb 19 21:54:00 JST 2005 Naoyuki Sawa
 *	- 쐬JnB
 */

extern RENDER render;			/* zVRAMւ̕` */
extern SURFACE surface;			/* zVRAM̃T[tFCX */
extern unsigned char vbuff[160 * 144];	/* zVRAM */

extern int now;				/* O[o^C} */
extern int joy;				/* pbh */

/*** File List ***/

#ifdef USE_STACK_SWITCH
extern unsigned char sram_stack[0x2000/**/];
#endif /*USE_STACK_SWITCH*/

extern FILEITEM* file_list;
extern int file_num;
extern int cursel;
extern int curtop;

/*** Emulation ***/

extern int mode; /* 0 = t@Cꗗ, 1 = Q[s */

extern FILE* rom_fp; /* ROMt@C (s͊JςȂł) */

extern unsigned char INPUT; /* MSB:{START,SELECT,B,A,DN,UP,LF,RI}:LSB */
extern int DIV;
extern int TIM;

/* $4000..$7FFFɑΉROMoN(tbṼAhX-0x4000)|Cg܂B
 * - %addr=0x4000..0x7fffŒڃItZbgł悤ɁABank#0=&rom[-0x4000]ƂĂ܂B
 *   ȉABank#1=&rom[0x0000], Bank#2=&rom[0x4000], Bank#3=&rom[0x8000],...Ƒ܂B
 *
 *   rom+0x0000 +--------------+
 *              |    Bank#0    |
 *   rom+0x4000 +--------------+ <- Ƃ΁ABank#2IĂꍇAROM_BANK͂w܂B
 *              |    Bank#1    |
 *   rom+0x8000 +--------------+
 *              |    Bank#2    | <- Ă΁AROM_BANK[%addr=0x4000..0x7FFF]Bank#2͈̔͂AhbVOł܂B
 *   rom+0xc000 +--------------+    (%addr0x4000A0x3fffAnd肷ԂȂ킯łB)
 *              |    Bank#3    |
 *              +--------------+
 *              |    Bank#4    |
 *              +--------------+
 *              |    Bank#...  |
 *              +--------------+
 *              |    Bank#N-1  |
 *              +--------------+
 */
extern const unsigned char* ROM_BANK;

/* $A000..$BFFFɑΉRAMoN(AhX-0xa000)|Cg܂B
 * - %addr=0xa000..0xbfffŒڃItZbgł悤ɁABank#0=&ram[-0xa000]ƂĂ܂B
 *   ȉABank#1=&ram[-0x8000], Bank#2=&ram[-0x6000], Bank#3=&ram[-0x4000],...Ƒ܂B
 */
extern unsigned char* RAM_BANK;
extern unsigned char ram[0x8000]; /* $A000-$C000: 8KBx4bank=32KB */
